#include "WRLWidgetComponent_h.h"

#include <wrl.h>

using ABI::WRLWidgetComponent::IWidget;
using ABI::WRLWidgetComponent::IWidgetFactory;

using Microsoft::WRL::ActivationFactory;
using Microsoft::WRL::Make;
using Microsoft::WRL::RuntimeClass;

class Widget : public RuntimeClass<IWidget>
{
    InspectableClass(RuntimeClass_WRLWidgetComponent_Widget, BaseTrust)
    
public:
    
    Widget()           : _number(0)      { }
    Widget(int number) : _number(number) { }
    
    STDMETHODIMP GetNumber(int* number) { *number = _number; return S_OK; }
    
private:
    
    INT32 _number;
};

class WidgetFactory : public ActivationFactory<IWidgetFactory>
{
    InspectableClassStatic(RuntimeClass_WRLWidgetComponent_Widget, BaseTrust)
    
public:
    
    STDMETHODIMP ActivateInstance(IInspectable** widget) override
    {
        *widget = Make<Widget>().Detach();
        return *widget != nullptr ? S_OK : E_OUTOFMEMORY;
    }
    
    STDMETHODIMP CreateInstance(int value, IWidget** widget) override
    {
        *widget = Make<Widget>(value).Detach();
        return *widget != nullptr ? S_OK : E_OUTOFMEMORY;
    }
};

ActivatableClassWithFactory(Widget, WidgetFactory)
